# coding: utf-8

"""
    URL Shortener API

    This API is responsible of authetication and the creation, modification and deletion of uris and hooks.  # noqa: E501

    OpenAPI spec version: 1.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six


class URI(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'uri_id': 'str',
        'user_id': 'int',
        'real_uri': 'str',
        'short_uri': 'str',
        'activated': 'bool',
        'reachable': 'bool',
        'safe': 'bool'
    }

    attribute_map = {
        'uri_id': 'uriId',
        'user_id': 'userId',
        'real_uri': 'realURI',
        'short_uri': 'shortURI',
        'activated': 'activated',
        'reachable': 'reachable',
        'safe': 'safe'
    }

    def __init__(self, uri_id=None, user_id=None, real_uri=None, short_uri=None, activated=None, reachable=None, safe=None):  # noqa: E501
        """URI - a model defined in Swagger"""  # noqa: E501
        self._uri_id = None
        self._user_id = None
        self._real_uri = None
        self._short_uri = None
        self._activated = None
        self._reachable = None
        self._safe = None
        self.discriminator = None
        if uri_id is not None:
            self.uri_id = uri_id
        if user_id is not None:
            self.user_id = user_id
        if real_uri is not None:
            self.real_uri = real_uri
        if short_uri is not None:
            self.short_uri = short_uri
        if activated is not None:
            self.activated = activated
        if reachable is not None:
            self.reachable = reachable
        if safe is not None:
            self.safe = safe

    @property
    def uri_id(self):
        """Gets the uri_id of this URI.  # noqa: E501


        :return: The uri_id of this URI.  # noqa: E501
        :rtype: str
        """
        return self._uri_id

    @uri_id.setter
    def uri_id(self, uri_id):
        """Sets the uri_id of this URI.


        :param uri_id: The uri_id of this URI.  # noqa: E501
        :type: str
        """

        self._uri_id = uri_id

    @property
    def user_id(self):
        """Gets the user_id of this URI.  # noqa: E501


        :return: The user_id of this URI.  # noqa: E501
        :rtype: int
        """
        return self._user_id

    @user_id.setter
    def user_id(self, user_id):
        """Sets the user_id of this URI.


        :param user_id: The user_id of this URI.  # noqa: E501
        :type: int
        """

        self._user_id = user_id

    @property
    def real_uri(self):
        """Gets the real_uri of this URI.  # noqa: E501


        :return: The real_uri of this URI.  # noqa: E501
        :rtype: str
        """
        return self._real_uri

    @real_uri.setter
    def real_uri(self, real_uri):
        """Sets the real_uri of this URI.


        :param real_uri: The real_uri of this URI.  # noqa: E501
        :type: str
        """

        self._real_uri = real_uri

    @property
    def short_uri(self):
        """Gets the short_uri of this URI.  # noqa: E501


        :return: The short_uri of this URI.  # noqa: E501
        :rtype: str
        """
        return self._short_uri

    @short_uri.setter
    def short_uri(self, short_uri):
        """Sets the short_uri of this URI.


        :param short_uri: The short_uri of this URI.  # noqa: E501
        :type: str
        """

        self._short_uri = short_uri

    @property
    def activated(self):
        """Gets the activated of this URI.  # noqa: E501


        :return: The activated of this URI.  # noqa: E501
        :rtype: bool
        """
        return self._activated

    @activated.setter
    def activated(self, activated):
        """Sets the activated of this URI.


        :param activated: The activated of this URI.  # noqa: E501
        :type: bool
        """

        self._activated = activated

    @property
    def reachable(self):
        """Gets the reachable of this URI.  # noqa: E501


        :return: The reachable of this URI.  # noqa: E501
        :rtype: bool
        """
        return self._reachable

    @reachable.setter
    def reachable(self, reachable):
        """Sets the reachable of this URI.


        :param reachable: The reachable of this URI.  # noqa: E501
        :type: bool
        """

        self._reachable = reachable

    @property
    def safe(self):
        """Gets the safe of this URI.  # noqa: E501


        :return: The safe of this URI.  # noqa: E501
        :rtype: bool
        """
        return self._safe

    @safe.setter
    def safe(self, safe):
        """Sets the safe of this URI.


        :param safe: The safe of this URI.  # noqa: E501
        :type: bool
        """

        self._safe = safe

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(URI, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, URI):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
